﻿using System;
using System.Collections.Generic;
using DevExpress.Persistent.Base;
using DevExpress.Persistent.BaseImpl;
using DevExpress.Persistent.Validation;
using DevExpress.Xpo;

namespace Ticket36921.Module.BusinessObjects
{
	[NavigationItem]
	public class Order : BaseObject
	{
		public Order(Session session) : base(session)
		{

		}

		public string Number
		{
			get { return this.GetPropertyValue<string>("Number"); }
			set { this.SetPropertyValue("Number", value); }
		}
		public decimal Total { get; set; }

		public Customer Customer
		{
			get { return this.GetPropertyValue<Customer>("Customer"); }
			set { this.SetPropertyValue("Customer", value); }
		}


		[Association("Order-Details", typeof(OrderDetails))]
		[Aggregated]
		public XPCollection<OrderDetails> OrderDetails
		{
			get { return this.GetCollection<OrderDetails>("OrderDetails"); }
		}

		public decimal Freight
		{
			get { return this.GetPropertyValue<decimal>("Freight"); }
			set { this.SetPropertyValue("Freight", value); }
		}

	}
}
