﻿using System;
using System.Text;
using System.Linq;
using DevExpress.ExpressApp;
using System.ComponentModel;
using DevExpress.ExpressApp.DC;
using System.Collections.Generic;
using DevExpress.Persistent.Base;
using DevExpress.Persistent.BaseImpl;
using DevExpress.ExpressApp.Model;
using DevExpress.ExpressApp.Actions;
using DevExpress.ExpressApp.Editors;
using DevExpress.ExpressApp.Updating;
using DevExpress.ExpressApp.Model.Core;
using DevExpress.ExpressApp.Model.DomainLogics;
using DevExpress.ExpressApp.Model.NodeGenerators;
using DevExpress.ExpressApp.Xpo;
using Ticket36921.Module.BusinessOperations;
using Ticket36921.Module.Settings;
using Xafari;
using Xafari.BC;
using Xafari.BC.BusinessOperations;
using Xafari.BC.Settings;
using Xafari.BC.Settings.Runtime;
using Xafari.Module.Localization;

namespace Ticket36921.Module
{
	// For more typical usage scenarios, be sure to check out https://documentation.devexpress.com/eXpressAppFramework/clsDevExpressExpressAppModuleBasetopic.aspx.
	public sealed partial class Ticket36921Module : XafariModuleBase, ITypesProvider<IBusinessOperation>,
		ITypesProvider<IOperationService>
	{
		public Ticket36921Module()
		{
			InitializeComponent();
			BaseObject.OidInitializationMode = OidInitializationMode.AfterConstruction;
			SettingsAccessor.CreateServiceInstance = xafApplication => new SettingsAccessorDesigner().CreateSettingsAccessor();
		}

		public override IEnumerable<ModuleUpdater> GetModuleUpdaters(IObjectSpace objectSpace, Version versionFromDB)
		{
			ModuleUpdater updater = new DatabaseUpdate.Updater(objectSpace, versionFromDB);
			return new ModuleUpdater[] {updater};
		}

		public override void Setup(XafApplication application)
		{
			base.Setup(application);
			// Manage various aspects of the application UI and behavior at the module level.
		}

		public override void CustomizeTypesInfo(ITypesInfo typesInfo)
		{
			base.CustomizeTypesInfo(typesInfo);
			CalculatedPersistentAliasHelper.CustomizeTypesInfo(typesInfo);
		}

		public override ICollection<Type> GetXafResourceLocalizerTypes()
		{
			return new Type[] {typeof(ModuleLocalizer)};
		}

		IEnumerable<Type> ITypesProvider<IBusinessOperation>.GetTypes()
		{
			return new[]
			{
				typeof(RuntimeBusinessOperation),
			};
		}

		IEnumerable<Type> ITypesProvider<IOperationService>.GetTypes()
		{
			return new[]
			{
				typeof(RuntimeCalc),

			};
		}

		public override void ExtendModelInterfaces(ModelInterfaceExtenders extenders)
		{
			extenders.Add<IModelBCSettings, IModelProjectSettings>();
		}
	}
}
