﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using DevExpress.ExpressApp.DC;
using DevExpress.Persistent.Base;
using Ticket36921.Module.BusinessOperations;
using Xafari;
using Xafari.BC.Settings;

namespace Ticket36921.Module.Settings
{
	public interface  IModelProjectSettings
	{
		BusinessOperationsSettings BusinessOperations { get; }
	}

	public interface BusinessOperationsSettings : IModelBCSettingsGroup
	{
		RuntimeBusinessOperationSettings RuntimeBusinessOperation { get; }
	}


	public interface RuntimeBusinessOperationSettings : IModelBCSettingsGroup
	{
		[EditorAlias(XafariEditorAliases.ExpressionPropertyEditor)]
		IModelKeyString Expression { get; }
	}

	public interface IModelKeyRuntimeBusinessOperationObject : IModelBCSettingsObjectItem<RuntimeBusinessOperation>
	{

	}

	[DomainLogic(typeof(IModelKeyRuntimeBusinessOperationObject))]
	public class IModelKeyEmployeeObjectLogic : IModelBCSettingsXPObjectItemLogic<RuntimeBusinessOperation, IModelKeyRuntimeBusinessOperationObject>
	{
		public IModelKeyEmployeeObjectLogic(IModelKeyRuntimeBusinessOperationObject instance) : base(instance)
		{
		}
	}

	public static class KeysProject
	{
		public static IModelProjectSettings KeysProjectSettings(this IModelBCSettings iModelBCSettings)
		{
			return (IModelProjectSettings) iModelBCSettings;
		}
	}

}
